"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.spawnPuppet = void 0;
var fs = __importStar(require("fs"));
var path = __importStar(require("path"));
var puppeteer_core_1 = require("puppeteer-core");
var url_1 = require("url");
var chrome_location_1 = require("./chrome-location");
var host_bindings_1 = require("./host-bindings");
var plugins_1 = require("./plugins");
var script_error_1 = __importDefault(require("./script-error"));
var pendingPagePromises = [];
function trackPendingPagePromise(promise) {
    pendingPagePromises.push(promise);
    return promise;
}
function loadBundle(page, bundleFilePath, serverURL) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, page.addScriptTag({
                        content: fs.readFileSync(require.resolve("sourcemapped-stacktrace/dist/sourcemapped-stacktrace.js"), "utf8")
                    })];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, page.addScriptTag({
                            url: new url_1.URL(bundleFilePath, serverURL).toString()
                        })];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
function resolveStackTrace(page, stackTrace) {
    return __awaiter(this, void 0, void 0, function () {
        var resolvedStackTrace, replacePathInStackTrace;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, page.evaluate(function (stack) { return new Promise(function (resolve) {
                        return window.sourceMappedStackTrace.mapStackTrace(stack, function (newStack) {
                            resolve(newStack.join("\n"));
                        });
                    }); }, stackTrace)];
                case 1:
                    resolvedStackTrace = _a.sent();
                    replacePathInStackTrace = function (matched, matchedPath) {
                        return matched.replace(matchedPath, path.relative(process.cwd(), matchedPath));
                    };
                    return [2 /*return*/, resolvedStackTrace.replace(/    at [^\(]+\((\.\.[^:]+):[0-9]/gm, replacePathInStackTrace)];
            }
        });
    });
}
function resolveToScriptError(page, error) {
    return __awaiter(this, void 0, void 0, function () {
        var endOfActualMessageIndex, messageWithStack, messageWithResolvedStack, _a, _b, _c, _d, _e;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    if (!!error.stack) return [3 /*break*/, 3];
                    endOfActualMessageIndex = error.message ? error.message.indexOf("\n    at ") : -1;
                    if (!(endOfActualMessageIndex === -1)) return [3 /*break*/, 1];
                    return [2 /*return*/, new script_error_1.default(error)];
                case 1:
                    messageWithStack = error.message;
                    _a = [error.message.substr(0, endOfActualMessageIndex)];
                    return [4 /*yield*/, resolveStackTrace(page, messageWithStack)];
                case 2:
                    messageWithResolvedStack = _a.concat([
                        _f.sent()
                    ]).join("\n");
                    error.message = error.message.substr(0, endOfActualMessageIndex);
                    return [2 /*return*/, new script_error_1.default(error, messageWithResolvedStack)];
                case 3:
                    if (!Array.isArray(error.stack)) return [3 /*break*/, 5];
                    _b = script_error_1.default.bind;
                    _c = [void 0, error];
                    return [4 /*yield*/, resolveStackTrace(page, error.stack.join("\n"))];
                case 4: return [2 /*return*/, new (_b.apply(script_error_1.default, _c.concat([_f.sent()])))()];
                case 5:
                    _d = script_error_1.default.bind;
                    _e = [void 0, error];
                    return [4 /*yield*/, resolveStackTrace(page, error.stack)];
                case 6: return [2 /*return*/, new (_d.apply(script_error_1.default, _e.concat([_f.sent()])))()];
            }
        });
    });
}
function createExitPromise(page) {
    var exited = false;
    return new Promise(function (resolve, reject) {
        host_bindings_1.subscribeToMagicLogs(page, function (type, args) {
            if (type === "exit") {
                exited = true;
                resolve(args[0]);
            }
        });
        // tslint:disable-next-line:no-console
        var fail = function (error) { return exited ? console.error(error) : reject(error); };
        var handleScriptError = function (error) {
            trackPendingPagePromise(resolveToScriptError(page, error))
                .then(function (scriptError) { return fail(scriptError); })
                .catch(function (internalError) {
                // tslint:disable:no-console
                console.error("Internal error while resolving script error:");
                console.error(internalError);
                // tslint:enable:no-console
                fail(error);
            });
        };
        page.once("error", handleScriptError);
        page.once("pageerror", handleScriptError);
    });
}
function spawnPuppet(bundleFilePaths, serverURL, options) {
    return __awaiter(this, void 0, void 0, function () {
        var puppetExit, _a, headless, browser, _b, page;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _a = options.headless, headless = _a === void 0 ? true : _a;
                    return [4 /*yield*/, puppeteer_core_1.launch({
                            executablePath: chrome_location_1.getChromeLocation() || undefined,
                            headless: headless
                        })];
                case 1:
                    browser = _c.sent();
                    return [4 /*yield*/, browser.pages()
                        // Navigate to a secure origin first. See <https://github.com/GoogleChrome/puppeteer/issues/2301>
                    ];
                case 2:
                    _b = __read.apply(void 0, [_c.sent()
                        // Navigate to a secure origin first. See <https://github.com/GoogleChrome/puppeteer/issues/2301>
                        , 1]), page = _b[0];
                    // Navigate to a secure origin first. See <https://github.com/GoogleChrome/puppeteer/issues/2301>
                    return [4 /*yield*/, page.goto(serverURL + "index.html")];
                case 3:
                    // Navigate to a secure origin first. See <https://github.com/GoogleChrome/puppeteer/issues/2301>
                    _c.sent();
                    host_bindings_1.capturePuppetConsole(page);
                    host_bindings_1.captureFailedRequests(page);
                    return [2 /*return*/, {
                            close: function () {
                                return __awaiter(this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                if (!headless) return [3 /*break*/, 3];
                                                return [4 /*yield*/, Promise.all(pendingPagePromises)];
                                            case 1:
                                                _a.sent();
                                                return [4 /*yield*/, browser.close()];
                                            case 2:
                                                _a.sent();
                                                return [3 /*break*/, 4];
                                            case 3: return [2 /*return*/, new Promise(function (resolve) { return undefined; })];
                                            case 4: return [2 /*return*/];
                                        }
                                    });
                                });
                            },
                            run: function (argv, plugins) {
                                if (plugins === void 0) { plugins = []; }
                                return __awaiter(this, void 0, void 0, function () {
                                    var pluginsConfig, contextConfig, bundleFilePaths_1, bundleFilePaths_1_1, bundlePath, e_1_1;
                                    var e_1, _a;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0: return [4 /*yield*/, plugins_1.createRuntimeConfig(plugins, argv)];
                                            case 1:
                                                pluginsConfig = _b.sent();
                                                contextConfig = host_bindings_1.createPuppetContextConfig(argv, pluginsConfig);
                                                puppetExit = createExitPromise(page);
                                                return [4 /*yield*/, host_bindings_1.injectPuppetContext(page, contextConfig)
                                                    // Load bundles sequentially
                                                ];
                                            case 2:
                                                _b.sent();
                                                _b.label = 3;
                                            case 3:
                                                _b.trys.push([3, 8, 9, 10]);
                                                bundleFilePaths_1 = __values(bundleFilePaths), bundleFilePaths_1_1 = bundleFilePaths_1.next();
                                                _b.label = 4;
                                            case 4:
                                                if (!!bundleFilePaths_1_1.done) return [3 /*break*/, 7];
                                                bundlePath = bundleFilePaths_1_1.value;
                                                return [4 /*yield*/, loadBundle(page, bundlePath, serverURL)];
                                            case 5:
                                                _b.sent();
                                                _b.label = 6;
                                            case 6:
                                                bundleFilePaths_1_1 = bundleFilePaths_1.next();
                                                return [3 /*break*/, 4];
                                            case 7: return [3 /*break*/, 10];
                                            case 8:
                                                e_1_1 = _b.sent();
                                                e_1 = { error: e_1_1 };
                                                return [3 /*break*/, 10];
                                            case 9:
                                                try {
                                                    if (bundleFilePaths_1_1 && !bundleFilePaths_1_1.done && (_a = bundleFilePaths_1.return)) _a.call(bundleFilePaths_1);
                                                }
                                                finally { if (e_1) throw e_1.error; }
                                                return [7 /*endfinally*/];
                                            case 10: return [2 /*return*/];
                                        }
                                    });
                                });
                            },
                            waitForExit: function () {
                                return __awaiter(this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        return [2 /*return*/, puppetExit];
                                    });
                                });
                            },
                            off: page.removeListener.bind(page),
                            on: page.on.bind(page),
                            once: page.once.bind(page),
                        }];
            }
        });
    });
}
exports.spawnPuppet = spawnPuppet;
