"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable-next-line:no-shadowed-variable
var ScriptError = function ScriptError(error, stack) {
    Error.call(this, error);
    Object.defineProperty(this, "message", {
        enumerable: false,
        value: error.message
    });
    Object.defineProperty(this, "stack", {
        enumerable: false,
        value: stack || error.stack
    });
};
ScriptError.prototype = new Error();
ScriptError.prototype.name = "ScriptError";
exports.default = ScriptError;
