"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeBlankHtmlPage = exports.clearTemporaryFileCache = exports.createTemporaryFileCache = void 0;
var fs = __importStar(require("fs"));
var os = __importStar(require("os"));
var path = __importStar(require("path"));
var del_1 = __importDefault(require("del"));
function createTemporaryFileCache() {
    return fs.mkdtempSync(path.join(os.tmpdir(), "puppet-run-cache"));
}
exports.createTemporaryFileCache = createTemporaryFileCache;
function clearTemporaryFileCache(cache) {
    del_1.default.sync([cache], { force: true });
}
exports.clearTemporaryFileCache = clearTemporaryFileCache;
function writeBlankHtmlPage(filePath) {
    var content = "\n    <!doctype html>\n    <html>\n      <head></head>\n      <body><!-- Blank page as a launch pad to inject JS scripts into --></body>\n    </html>\n  ".trim();
    fs.writeFileSync(filePath, content, "utf8");
}
exports.writeBlankHtmlPage = writeBlankHtmlPage;
